variables:
  REGION: eu-west-1
  DOCKER_PATH_PCU: libs/phenom-communications-types/Dockerfile
  BUILD_IMAGE_PCU: $CI_REGISTRY_IMAGE/phenom-communications-types:$CI_COMMIT_SHA
  LATEST_BUILD_IMAGE_PCU: $CI_REGISTRY_IMAGE/phenom-communications-types:latest

setup:phenom-communications-types:
  image: docker
  stage: setup
  services:
    - docker:18.09.7-dind
  only:
    refs:
      - merge_requests
      - master
    changes:
      - 'libs/phenom-communications-types/**/*'
      - '.gitlab-ci.yml'
      - 'jest.config.js'
      - 'nx.json'
      - 'package.json'
      - 'tsconfig.base.json'
      - 'workspace.json'
      - 'yarn.lock'
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker pull $LATEST_BUILD_IMAGE_PCU || true
    - docker build --cache-from $LATEST_BUILD_IMAGE_PCU -t $BUILD_IMAGE_PCU -t $LATEST_BUILD_IMAGE_PCU -f $DOCKER_PATH_PCU .
    - docker push $BUILD_IMAGE_PCU
    - docker push $LATEST_BUILD_IMAGE_PCU

publish:phenom-communications-types:
  needs: ["setup:phenom-communications-types"]
  when: manual
  stage: publish
  image: $BUILD_IMAGE_PCU
  services:
    - docker:18.09.7-dind
  script:
    - cd /home/phenom-communications
    - cp ./.npmrc_sample ./dist/libs/phenom-communications-types/.npmrc
    - cd ./dist/libs/phenom-communications-types/
    - CI_PROJECT_ID="${CI_PROJECT_ID}" CI_JOB_TOKEN="${CI_JOB_TOKEN}" npm publish
  only:
    refs:
      - merge_requests
      - master
    changes:
      - 'libs/phenom-communications-types/**/*'
      - '.gitlab-ci.yml'
      - 'jest.config.js'
      - 'nx.json'
      - 'package.json'
      - 'tsconfig.base.json'
      - 'workspace.json'
      - 'yarn.lock'
